﻿using Microsoft.AspNetCore.Mvc.ModelBinding;
using Microsoft.AspNetCore.Mvc.ModelBinding.Binders;
using System;

namespace Falcon.SugarApi.ClaimTicket
{
    /// <summary>
    /// ClaimTicket模型绑定提供器
    /// </summary>
    public class ClaimTicketModelBindingProvider:IModelBinderProvider
    {
        IModelBinder? IModelBinderProvider.GetBinder(ModelBinderProviderContext context) {
            if(context == null) {
                throw new ArgumentNullException(nameof(context));
            }

            if(context.Metadata.ModelType.IsAssignableTo(typeof(UserTicket))) {
                return new BinderTypeModelBinder(typeof(ClaimTicketModelBinding));
            }

            return null;
        }
    }
}
