﻿using System;

namespace Falcon.SugarApi.DatabaseManager
{
    /// <summary>
    /// 数据库事务执行中产生的异常
    /// </summary>
    public class DatabaseTranException:Exception
    {
        /// <summary>
        /// 构造数据库事务执行时产生的异常
        /// </summary>
        public DatabaseTranException() : base("执行数据库事务时发生异常！") { }
        /// <summary>
        /// 构造数据库事务执行时产生的异常，并携带内部异常
        /// </summary>
        /// <param name="innException">内部异常</param>
        public DatabaseTranException(Exception innException) : base("执行数据库事务时发生异常！",innException) { }
    }

    /// <summary>
    /// 存储过程执行异常
    /// </summary>
    public class DatabaseStoredProceduresExcuteException:Exception
    {

    }
}
